{                          
  Propeller Based Reverse- GeoCache Project Version X.P12
  Andrew Williams
  (WBA Consulting)
  dru@aestheticacoustics.com

  GPS portions started with Google Earth KML Logger by "paul_h" 

USAGE:
  -  Still in development, but full details will be right here when it is finalized

DEVELOPMENT VERSIONING
    000  -  Modified pin assignments for my demo board setup (currently no switch, assigned to unused pin)
    001  -  Added LED2 for "is Longitude > 99" status check
    002  -  changed atoi string from 3 to 4
    003  -  Added multiple longitude routines for debugging
    004  -  Modified longitude routines for debugging
    005  -  Removed extra longitude routines, kept working one
    006  -  Resequenced longitude and latitude routines
    007  -  Resequenced longitude and latitude routines, updated header and footer in fake dat section, added switch at P0
    P08  -  Moved to PPDB, added uOLED, stripped down code
    P09  -  Modified display features
    P10  -  Added Servo functions
    P11  -  Added Matching routine to Longitude  (green value means match) and SW01 unlock bypass routine
    P12  -  Added Matching routine to Latitude, minor housekeeping, set lat/lon to Parallax, LED2 commented out


TO DO LIST:
   1) EEPROM flagging for number of locations found
   2) Routine for checking EEPROM flag
   3) Change target lat/lon to variables
   4) Finalize lock/unlock functions
   5) Full Test Run
   6) Migrate to USB Protoboard
   7) Install into case
   8) Cross fingers   


    38.812790,-121.296133 = Parallax
}
   
CON

  _CLKMODE            = XTAL1 + PLL16X
  _XINFREQ            = 5_000_000
  _stack              = 48

' GPS Assignments                                        
  GPSin     = 26                                        ' fm GPS
  GPSout    = 25                                        ' to GPS (unused)

  SW01      = 00

  LED1      = 02
'  LED2      = 03
                                                                                                                
VAR
  byte s,d,datum[64]                                    ' space for file copying 
  long SAddr
  long MAddr
  word Type
  word HW
  word SW
  word DevX
  word DevY
  word red
  word green
    
OBJ                                                    
  gps        :  "GPS_IO_mini_PNAV"                      ' Services GPS input and etrex extension           
  dm         :  "DynamicMathLib"                        ' MK's cog-reduced code
  fmt        :  "format"                                ' Used for reformatting data between NUM, STR, types.
  num        :  "Numbers"
  OLED       :  "uOLED-128-GMD1"                        ' uOLED 128 display
  DELAY      :  "Clock"
  servo      :  "servoEngine1"                          ' Dual Servo Driver
  eeprom     :  "ROMEngine"                             ' Simple EEPROM object
 
PUB start           ' this section needs cleanup

''Initialize all necessary routines into their cogs as appropriate
dira[LED1]~~                                            ' set LEDs to be outputs
'dira[LED2]~~                                            ' set LEDs to be outputs
dira[SW01]~                                             ' set switch to be input

  gps.start(GPSin,GPSout)                               ' start GPS ingest (gets its own cog)
  OLED.INIT                       
  DELAY.PauseSec(1)
  SETUP
  servo.servoEngine
 
   if INA[SW01] == 1
     happybday
   else
     progressbar
 
  OLED.FTEXT(2,3, 2, 100,255,255, string("GPS...."),0)
  DELAY.PauseSec(1)
  CheckForSatellite                                     ' make sure GPS is active before continuing
  waitcnt(12_000_000 + cnt)                             ' stabilize, housekeeping loop cycle time (~1 sec)

  SETUP
num.init                                                ' numbers and math routines
ControlLoop                                             ' overall loop

PUB ControlLoop                  ' this section is clean
 checklatlon
 DELAY.PauseSec(1)

 IF INA[SW01] == 0                 ' use to reset uOLED in case it locks up
   OLED.power(0)
   DELAY.PauseSec(1)
   OLED.power(1)
   
 ControlLoop

 
   
PUB SETUP                        ' this section is clean
  OLED.ERASE
  DELAY.PauseMSec(20)
  OLED.BACKGROUND(0,0,0)

PUB HAPPYBDAY                    ' this section is clean
  
    OLED.INIT                       
    DELAY.PauseSec(1)
    SETUP
    OLED.ERASE
    DELAY.PausemSec(300)
  repeat 5
    OLED.FTEXT(2,3, 2, 100,255,255, string("Happy"),0)
    OLED.FTEXT(4,5, 2, 255,100,255, string("Birthday"),0)
    OLED.FTEXT(6,7, 2, 255,255,100, string("Chelle!"),0)
    DELAY.PausemSec(300)
    oled.erase
    DELAY.PausemSec(300)
  DELAY.PauseSec(2)                                          
  OLED.ERASE

  SETUP

PUB checklatlon | idx, DD, d8, decDD, temp, match, i             ' this section needs cleanup

 OLED.erase
 OLED.FTEXT(2,1, 2, 200,255,200, string("GPS MATCHING:"),0)

'Longitude Matching
 OLED.FTEXT(0,3, 2, 255,0,20, string(">-121.296133"),0)                 ' 38.81279,-121.296133

  d8 := atoi(gps.longitude+3,2) * 100_000 / 6           ' 8 digit, frac degrees. intermediate needed before conv to string for accuracy.
  d8 += atoi(gps.longitude+6,4) * 10 /6             
  decDD    := num.ToStr(d8,Num#DEC7)                           ' string of the decimal component

   If atoi(gps.longitude,3) == 121 AND ||(296133 - d8) < 100
      red := 0
      green := 255
   Else
      red := 255
      green := 0

 'Longitude Display        
  DD     := num.ToStr(atoi(gps.longitude,3),Num#DEC4)   ' whole degrees - DEC# is the number of digits needed in the string
  OLED.FTEXT(1,4, 2, red,green,0, string("-"),0)          ' Correct sign for western hemisphere, manually for now
   if atoi(gps.longitude,3) > 99                         ' 
     OLED.FTEXT(1,4, 2, red,green,0, num.ToStr(atoi(gps.longitude,3),Num#DEC4),0)
  OLED.FTEXT(5,4, 2, red,green,0, string("."),0)
  d8 := atoi(gps.longitude+3,2) * 100_000 / 6           ' 8 digit, frac degrees. intermediate needed before conv to string for accuracy.
  d8 += atoi(gps.longitude+6,4) * 10 /6             
  decDD    := num.ToStr(d8,Num#DEC7)                           ' string of the decimal component
  OLED.FTEXT(5,4, 2, red,green,0,decDD,0)

'Latitude Matching
 OLED.FTEXT(0,6, 2, 255,0,20, string("> 38.812790"),0)
  d8 := atoi(gps.latitude+2,2) * 100_000 / 6            ' intermediate needed before conv to string for accuracy.
  d8 += atoi(gps.latitude+5,4) * 10 /6             
  decDD    := num.ToStr(d8,Num#DEC7)                    ' 7byte string of the decimal component

   If atoi(gps.latitude,2) == 38 AND ||(812790 - d8) < 100      ' Looking for 
      red := 0
      green := 255
   Else
      red := 255
      green := 0


'Latitude Display
  DD     := num.ToStr(atoi(gps.latitude,2),Num#DEC3)    ' whole degrees - write as is. It is only 2 digits
  OLED.FTEXT(1,7, 2, red,green,0, num.ToStr(atoi(gps.latitude,2),Num#DEC3),0)
  OLED.FTEXT(4,7, 2, red,green,0, string("."),0)
  d8 := atoi(gps.latitude+2,2) * 100_000 / 6            ' intermediate needed before conv to string for accuracy.
  d8 += atoi(gps.latitude+5,4) * 10 /6             
  decDD    := num.ToStr(d8,Num#DEC7)                    ' 7byte string of the decimal component
  OLED.FTEXT(4,7, 2, red,green,0,decDD,0) 
    
PUB Progressbar | Temp                    ' this section is clean
   
  REPEAT Temp from 10 to 120 step 2                      'Right
   OLED.PUT_PIXEL(Temp,110, 255,0,0)
    IF INA[SW01] == 1
      reboot
   DELAY.PauseMSec(100)

  if INA[SW01] == 0
    unlock
  else
    OLED.erase
    OLED.FTEXT(0,0,2, 0,255,0, string("error"),0)
    DELAY.PauseSec(4)
  reboot
   
Pub unlock                                ' this section is clean, but unfinished

    OLED.erase
    OLED.FTEXT(0,0, 2, 0,255,0, string("OPENING"),0)
    servo.setPositionA(180)
    DELAY.PauseSec(10)
    reboot
  
Pub CheckForSatellite | valid, i              ' this section is clean
repeat
   toggle(LED1)

while byte[gps.valid] <> "A"                            ' display search status onscreen 


PUB atoi( pptr,c)| ptrr, sign                           ' convert c characters into number     ' this section is clean
  result := sign := 0
  if byte[pptr] == "-"
      sign++
      pptr++
  c--    
  repeat ptrr from 0 to c
    if byte[pptr+ptrr] == 0                             ' stop if null
         quit
         
    if byte[pptr+ptrr] == "."                           ' stop at decimal point
         quit
    else     
       result := result * 10 + (byte[pptr+ptrr] - "0")
  if sign == 1
    result := -result
          

PUB Toggle(pin)                   ' this section is clean
  dira[Pin]~~
  outa[pin]~~                                                            
  repeat 2
    !outa[Pin]
    waitcnt(500_0000 + cnt)